<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "appointment".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Appointment".
 *
 * Columns in table "appointment" available as properties of the model,
 * followed by relations of table "appointment" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property integer $cpn_ehr_installation_id
 * @property integer $patient_id
 * @property string $status
 * @property integer $no_show
 * @property string $first_name
 * @property string $last_name
 * @property string $cell_phone
 * @property string $email
 * @property string $appointment_date
 * @property string $time_start
 * @property string $time_end
 * @property string $ny_start_datetime
 * @property string $reason
 * @property string $previous_date
 * @property string $previous_time_start
 * @property string $previous_time_end
 * @property string $insurance_company_other
 * @property string $emr_appointment_id
 * @property string $date_added
 * @property string $date_updated
 *
 * @property CpnEhrInstallation $cpnEhrInstallation
 * @property Practice $practice
 * @property Provider $provider
 * @property Patient $patient
 */
abstract class BaseAppointment extends BaseModel
{

    public $providerSearch;
    public $cpnInstallationSearch;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'appointment';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Appointment|Appointments', $n);
    }

    public static function representingColumn()
    {
        return 'status';
    }

    public function rules()
    {
        return array(
            array('practice_id, provider_id, status, first_name, last_name, appointment_date, '
                . 'date_updated', 'required'),
            array('practice_id, provider_id, cpn_ehr_installation_id, patient_id, no_show', 'numerical',
                'integerOnly' => true),
            array('status', 'length', 'max' => 1),
            array('first_name, last_name, cell_phone, insurance_company_other', 'length', 'max' => 50),
            array('email', 'length', 'max' => 100),
            array('reason', 'length', 'max' => 255),
            array('emr_appointment_id', 'length', 'max' => 40),
            array('time_start, time_end, previous_date, previous_time_start, previous_time_end, date_added', 'safe'),
            array('cpn_ehr_installation_id, patient_id, no_show, cell_phone, email, time_start, time_end,
                reason, previous_date, previous_time_start, previous_time_end,
                insurance_company_other, emr_appointment_id, date_added', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, practice_id, provider_id, cpn_ehr_installation_id, patient_id, status, no_show,
                first_name, last_name, cell_phone, email, appointment_date,
                time_start, time_end, ny_start_datetime, reason, previous_date, previous_time_start,
                previous_time_end, insurance_company_other, emr_appointment_id,
                date_added, date_updated', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnEhrInstallation' => array(self::BELONGS_TO, 'CpnEhrInstallation', 'cpn_ehr_installation_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'patient' => array(self::BELONGS_TO, 'Patient', 'patient_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => null,
            'provider_id' => null,
            'cpn_ehr_installation_id' => null,
            'patient_id' => null,
            'status' => Yii::t('app', 'Status'),
            'no_show' => Yii::t('app', 'No Show'),
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'cell_phone' => Yii::t('app', 'Cell Phone'),
            'email' => Yii::t('app', 'Email'),
            'appointment_date' => Yii::t('app', 'Appointment Date'),
            'time_start' => Yii::t('app', 'Time Start'),
            'time_end' => Yii::t('app', 'Time End'),
            'ny_start_datetime' => Yii::t('app', 'Ny Start Datetime'),
            'reason' => Yii::t('app', 'Reason'),
            'previous_date' => Yii::t('app', 'Previous Date'),
            'previous_time_start' => Yii::t('app', 'Previous Time Start'),
            'previous_time_end' => Yii::t('app', 'Previous Time End'),
            'insurance_company_other' => Yii::t('app', 'Insurance Company Other'),
            'emr_appointment_id' => Yii::t('app', 'Emr Appointment'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'cpnEhrInstallation' => null,
            'practice' => null,
            'provider' => null,
            'patient' => null,
            'cpnInstallationSearch' => Yii::t('app', 'Cpn Installation ID'),
            'providerSearch' => Yii::t('app', 'Provider Name'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->with = array('cpnEhrInstallation', 'provider');

        $criteria->compare('t.id', $this->id);
        $criteria->compare('t.practice_id', $this->practice_id);
        $criteria->compare('t.provider_id', $this->provider_id);
        $criteria->compare('t.cpn_ehr_installation_id', $this->cpn_ehr_installation_id);
        $criteria->compare('t.patient_id', $this->patient_id);
        $criteria->compare('t.status', $this->status, true);
        $criteria->compare('t.no_show', $this->no_show);
        $criteria->compare('t.first_name', $this->first_name, true);
        $criteria->compare('t.last_name', $this->last_name, true);
        $criteria->compare('t.cell_phone', $this->cell_phone, true);
        $criteria->compare('t.email', $this->email, true);
        $criteria->compare('t.appointment_date', $this->appointment_date, true);
        $criteria->compare('t.time_start', $this->time_start, true);
        $criteria->compare('t.time_end', $this->time_end, true);
        $criteria->compare('t.ny_start_datetime', $this->ny_start_datetime, true);
        $criteria->compare('t.reason', $this->reason, true);
        $criteria->compare('t.previous_date', $this->previous_date, true);
        $criteria->compare('t.previous_time_start', $this->previous_time_start, true);
        $criteria->compare('t.previous_time_end', $this->previous_time_end, true);
        $criteria->compare('t.insurance_company_other', $this->insurance_company_other, true);
        $criteria->compare('t.emr_appointment_id', $this->emr_appointment_id, true);
        $criteria->compare('t.date_added', $this->date_added, true);
        $criteria->compare('t.date_updated', $this->date_updated, true);

        $criteria->compare('cpn_installation_id', $this->cpnInstallationSearch);
        $criteria->compare('provider.first_last', $this->providerSearch, true);

        $criteria->order = 't.ny_start_datetime ASC';

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array(
                'pageSize' => 25,
            )
        ));
    }

}
